%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018-2024  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Distribution_Data = Read_Distribution_File(File_Name)

global ErrCode;

Distribution_Data = [];

% Открытие файла
Fin = fopen(File_Name, 'r');

if (Fin < 0)
    fprintf (1, '\nОшибка функции Read_Distribution_File: не удалось открыть файл %s !\n', File_Name);
    ErrCode = -1;
    return;
end

% Выделение памяти
Distribution_Data = zeros(1000,2);

% Инициализация счетчика
counter = 0;

% Чтение данных
while (~feof(Fin))
    
    string = strtrim(fgets(Fin));
    
    if (isempty(string))
        continue;
    end
    
    if (string(1) == '#')
        continue;
    end
    
    [tmp, count] = sscanf(string, '%e');
    
    if (count == 2)
        
        counter = counter + 1;
        
        Distribution_Data(counter,1) = tmp(1);
        Distribution_Data(counter,2) = tmp(2);
        
    else
        
        fprintf (1, '\nОшибка функции Read_Distribution_File: нарушен формат данных в файле %s !\n', File_Name);
        ErrCode = -1;
        fclose(Fin);
        return;
        
    end
    
end

% Закрытие файла
fclose(Fin);

% Проверка счетчика
if (counter == 0)
    fprintf (1, '\nОшибка функции Read_Distribution_File: файл %s не содержит данных!\n', File_Name);
    ErrCode = -1;
    return;
end

% Финализация массива
Distribution_Data = Distribution_Data(1:counter,:);
